diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ID3/module.tag.apetag.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ID3/module.tag.apetag.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ID3/module.tag.apetag.php	1969-12-31 18:00:00.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ID3/module.tag.apetag.php	2013-03-20 23:55:42.000000000 -0500
***************
*** 0 ****
--- 1,370 ----
+ <?php
+ /////////////////////////////////////////////////////////////////
+ /// getID3() by James Heinrich <info@getid3.org>               //
+ //  available at http://getid3.sourceforge.net                 //
+ //            or http://www.getid3.org                         //
+ /////////////////////////////////////////////////////////////////
+ // See readme.txt for more details                             //
+ /////////////////////////////////////////////////////////////////
+ //                                                             //
+ // module.tag.apetag.php                                       //
+ // module for analyzing APE tags                               //
+ // dependencies: NONE                                          //
+ //                                                            ///
+ /////////////////////////////////////////////////////////////////
+ 
+ class getid3_apetag extends getid3_handler
+ {
+ 	public $inline_attachments = true; // true: return full data for all attachments; false: return no data for all attachments; integer: return data for attachments <= than this; string: save as file to this directory
+ 	public $overrideendoffset  = 0;
+ 
+ 	public function Analyze() {
+ 		$info = &$this->getid3->info;
+ 
+ 		if (!getid3_lib::intValueSupported($info['filesize'])) {
+ 			$info['warning'][] = 'Unable to check for APEtags because file is larger than '.round(PHP_INT_MAX / 1073741824).'GB';
+ 			return false;
+ 		}
+ 
+ 		$id3v1tagsize     = 128;
+ 		$apetagheadersize = 32;
+ 		$lyrics3tagsize   = 10;
+ 
+ 		if ($this->overrideendoffset == 0) {
+ 
+ 			fseek($this->getid3->fp, 0 - $id3v1tagsize - $apetagheadersize - $lyrics3tagsize, SEEK_END);
+ 			$APEfooterID3v1 = fread($this->getid3->fp, $id3v1tagsize + $apetagheadersize + $lyrics3tagsize);
+ 
+ 			//if (preg_match('/APETAGEX.{24}TAG.{125}$/i', $APEfooterID3v1)) {
+ 			if (substr($APEfooterID3v1, strlen($APEfooterID3v1) - $id3v1tagsize - $apetagheadersize, 8) == 'APETAGEX') {
+ 
+ 				// APE tag found before ID3v1
+ 				$info['ape']['tag_offset_end'] = $info['filesize'] - $id3v1tagsize;
+ 
+ 			//} elseif (preg_match('/APETAGEX.{24}$/i', $APEfooterID3v1)) {
+ 			} elseif (substr($APEfooterID3v1, strlen($APEfooterID3v1) - $apetagheadersize, 8) == 'APETAGEX') {
+ 
+ 				// APE tag found, no ID3v1
+ 				$info['ape']['tag_offset_end'] = $info['filesize'];
+ 
+ 			}
+ 
+ 		} else {
+ 
+ 			fseek($this->getid3->fp, $this->overrideendoffset - $apetagheadersize, SEEK_SET);
+ 			if (fread($this->getid3->fp, 8) == 'APETAGEX') {
+ 				$info['ape']['tag_offset_end'] = $this->overrideendoffset;
+ 			}
+ 
+ 		}
+ 		if (!isset($info['ape']['tag_offset_end'])) {
+ 
+ 			// APE tag not found
+ 			unset($info['ape']);
+ 			return false;
+ 
+ 		}
+ 
+ 		// shortcut
+ 		$thisfile_ape = &$info['ape'];
+ 
+ 		fseek($this->getid3->fp, $thisfile_ape['tag_offset_end'] - $apetagheadersize, SEEK_SET);
+ 		$APEfooterData = fread($this->getid3->fp, 32);
+ 		if (!($thisfile_ape['footer'] = $this->parseAPEheaderFooter($APEfooterData))) {
+ 			$info['error'][] = 'Error parsing APE footer at offset '.$thisfile_ape['tag_offset_end'];
+ 			return false;
+ 		}
+ 
+ 		if (isset($thisfile_ape['footer']['flags']['header']) && $thisfile_ape['footer']['flags']['header']) {
+ 			fseek($this->getid3->fp, $thisfile_ape['tag_offset_end'] - $thisfile_ape['footer']['raw']['tagsize'] - $apetagheadersize, SEEK_SET);
+ 			$thisfile_ape['tag_offset_start'] = ftell($this->getid3->fp);
+ 			$APEtagData = fread($this->getid3->fp, $thisfile_ape['footer']['raw']['tagsize'] + $apetagheadersize);
+ 		} else {
+ 			$thisfile_ape['tag_offset_start'] = $thisfile_ape['tag_offset_end'] - $thisfile_ape['footer']['raw']['tagsize'];
+ 			fseek($this->getid3->fp, $thisfile_ape['tag_offset_start'], SEEK_SET);
+ 			$APEtagData = fread($this->getid3->fp, $thisfile_ape['footer']['raw']['tagsize']);
+ 		}
+ 		$info['avdataend'] = $thisfile_ape['tag_offset_start'];
+ 
+ 		if (isset($info['id3v1']['tag_offset_start']) && ($info['id3v1']['tag_offset_start'] < $thisfile_ape['tag_offset_end'])) {
+ 			$info['warning'][] = 'ID3v1 tag information ignored since it appears to be a false synch in APEtag data';
+ 			unset($info['id3v1']);
+ 			foreach ($info['warning'] as $key => $value) {
+ 				if ($value == 'Some ID3v1 fields do not use NULL characters for padding') {
+ 					unset($info['warning'][$key]);
+ 					sort($info['warning']);
+ 					break;
+ 				}
+ 			}
+ 		}
+ 
+ 		$offset = 0;
+ 		if (isset($thisfile_ape['footer']['flags']['header']) && $thisfile_ape['footer']['flags']['header']) {
+ 			if ($thisfile_ape['header'] = $this->parseAPEheaderFooter(substr($APEtagData, 0, $apetagheadersize))) {
+ 				$offset += $apetagheadersize;
+ 			} else {
+ 				$info['error'][] = 'Error parsing APE header at offset '.$thisfile_ape['tag_offset_start'];
+ 				return false;
+ 			}
+ 		}
+ 
+ 		// shortcut
+ 		$info['replay_gain'] = array();
+ 		$thisfile_replaygain = &$info['replay_gain'];
+ 
+ 		for ($i = 0; $i < $thisfile_ape['footer']['raw']['tag_items']; $i++) {
+ 			$value_size = getid3_lib::LittleEndian2Int(substr($APEtagData, $offset, 4));
+ 			$offset += 4;
+ 			$item_flags = getid3_lib::LittleEndian2Int(substr($APEtagData, $offset, 4));
+ 			$offset += 4;
+ 			if (strstr(substr($APEtagData, $offset), "\x00") === false) {
+ 				$info['error'][] = 'Cannot find null-byte (0x00) seperator between ItemKey #'.$i.' and value. ItemKey starts '.$offset.' bytes into the APE tag, at file offset '.($thisfile_ape['tag_offset_start'] + $offset);
+ 				return false;
+ 			}
+ 			$ItemKeyLength = strpos($APEtagData, "\x00", $offset) - $offset;
+ 			$item_key      = strtolower(substr($APEtagData, $offset, $ItemKeyLength));
+ 
+ 			// shortcut
+ 			$thisfile_ape['items'][$item_key] = array();
+ 			$thisfile_ape_items_current = &$thisfile_ape['items'][$item_key];
+ 
+ 			$thisfile_ape_items_current['offset'] = $thisfile_ape['tag_offset_start'] + $offset;
+ 
+ 			$offset += ($ItemKeyLength + 1); // skip 0x00 terminator
+ 			$thisfile_ape_items_current['data'] = substr($APEtagData, $offset, $value_size);
+ 			$offset += $value_size;
+ 
+ 			$thisfile_ape_items_current['flags'] = $this->parseAPEtagFlags($item_flags);
+ 			switch ($thisfile_ape_items_current['flags']['item_contents_raw']) {
+ 				case 0: // UTF-8
+ 				case 3: // Locator (URL, filename, etc), UTF-8 encoded
+ 					$thisfile_ape_items_current['data'] = explode("\x00", trim($thisfile_ape_items_current['data']));
+ 					break;
+ 
+ 				default: // binary data
+ 					break;
+ 			}
+ 
+ 			switch (strtolower($item_key)) {
+ 				case 'replaygain_track_gain':
+ 					$thisfile_replaygain['track']['adjustment'] = (float) str_replace(',', '.', $thisfile_ape_items_current['data'][0]); // float casting will see "0,95" as zero!
+ 					$thisfile_replaygain['track']['originator'] = 'unspecified';
+ 					break;
+ 
+ 				case 'replaygain_track_peak':
+ 					$thisfile_replaygain['track']['peak']       = (float) str_replace(',', '.', $thisfile_ape_items_current['data'][0]); // float casting will see "0,95" as zero!
+ 					$thisfile_replaygain['track']['originator'] = 'unspecified';
+ 					if ($thisfile_replaygain['track']['peak'] <= 0) {
+ 						$info['warning'][] = 'ReplayGain Track peak from APEtag appears invalid: '.$thisfile_replaygain['track']['peak'].' (original value = "'.$thisfile_ape_items_current['data'][0].'")';
+ 					}
+ 					break;
+ 
+ 				case 'replaygain_album_gain':
+ 					$thisfile_replaygain['album']['adjustment'] = (float) str_replace(',', '.', $thisfile_ape_items_current['data'][0]); // float casting will see "0,95" as zero!
+ 					$thisfile_replaygain['album']['originator'] = 'unspecified';
+ 					break;
+ 
+ 				case 'replaygain_album_peak':
+ 					$thisfile_replaygain['album']['peak']       = (float) str_replace(',', '.', $thisfile_ape_items_current['data'][0]); // float casting will see "0,95" as zero!
+ 					$thisfile_replaygain['album']['originator'] = 'unspecified';
+ 					if ($thisfile_replaygain['album']['peak'] <= 0) {
+ 						$info['warning'][] = 'ReplayGain Album peak from APEtag appears invalid: '.$thisfile_replaygain['album']['peak'].' (original value = "'.$thisfile_ape_items_current['data'][0].'")';
+ 					}
+ 					break;
+ 
+ 				case 'mp3gain_undo':
+ 					list($mp3gain_undo_left, $mp3gain_undo_right, $mp3gain_undo_wrap) = explode(',', $thisfile_ape_items_current['data'][0]);
+ 					$thisfile_replaygain['mp3gain']['undo_left']  = intval($mp3gain_undo_left);
+ 					$thisfile_replaygain['mp3gain']['undo_right'] = intval($mp3gain_undo_right);
+ 					$thisfile_replaygain['mp3gain']['undo_wrap']  = (($mp3gain_undo_wrap == 'Y') ? true : false);
+ 					break;
+ 
+ 				case 'mp3gain_minmax':
+ 					list($mp3gain_globalgain_min, $mp3gain_globalgain_max) = explode(',', $thisfile_ape_items_current['data'][0]);
+ 					$thisfile_replaygain['mp3gain']['globalgain_track_min'] = intval($mp3gain_globalgain_min);
+ 					$thisfile_replaygain['mp3gain']['globalgain_track_max'] = intval($mp3gain_globalgain_max);
+ 					break;
+ 
+ 				case 'mp3gain_album_minmax':
+ 					list($mp3gain_globalgain_album_min, $mp3gain_globalgain_album_max) = explode(',', $thisfile_ape_items_current['data'][0]);
+ 					$thisfile_replaygain['mp3gain']['globalgain_album_min'] = intval($mp3gain_globalgain_album_min);
+ 					$thisfile_replaygain['mp3gain']['globalgain_album_max'] = intval($mp3gain_globalgain_album_max);
+ 					break;
+ 
+ 				case 'tracknumber':
+ 					if (is_array($thisfile_ape_items_current['data'])) {
+ 						foreach ($thisfile_ape_items_current['data'] as $comment) {
+ 							$thisfile_ape['comments']['track'][] = $comment;
+ 						}
+ 					}
+ 					break;
+ 
+ 				case 'cover art (artist)':
+ 				case 'cover art (back)':
+ 				case 'cover art (band logo)':
+ 				case 'cover art (band)':
+ 				case 'cover art (colored fish)':
+ 				case 'cover art (composer)':
+ 				case 'cover art (conductor)':
+ 				case 'cover art (front)':
+ 				case 'cover art (icon)':
+ 				case 'cover art (illustration)':
+ 				case 'cover art (lead)':
+ 				case 'cover art (leaflet)':
+ 				case 'cover art (lyricist)':
+ 				case 'cover art (media)':
+ 				case 'cover art (movie scene)':
+ 				case 'cover art (other icon)':
+ 				case 'cover art (other)':
+ 				case 'cover art (performance)':
+ 				case 'cover art (publisher logo)':
+ 				case 'cover art (recording)':
+ 				case 'cover art (studio)':
+ 					// list of possible cover arts from http://taglib-sharp.sourcearchive.com/documentation/2.0.3.0-2/Ape_2Tag_8cs-source.html
+ 					list($thisfile_ape_items_current['filename'], $thisfile_ape_items_current['data']) = explode("\x00", $thisfile_ape_items_current['data'], 2);
+ 					$thisfile_ape_items_current['data_offset'] = $thisfile_ape_items_current['offset'] + strlen($thisfile_ape_items_current['filename']."\x00");
+ 					$thisfile_ape_items_current['data_length'] = strlen($thisfile_ape_items_current['data']);
+ 
+ 					$thisfile_ape_items_current['image_mime'] = '';
+ 					$imageinfo = array();
+ 					$imagechunkcheck = getid3_lib::GetDataImageSize($thisfile_ape_items_current['data'], $imageinfo);
+ 					$thisfile_ape_items_current['image_mime'] = image_type_to_mime_type($imagechunkcheck[2]);
+ 
+ 					do {
+ 						if ($this->inline_attachments === false) {
+ 							// skip entirely
+ 							unset($thisfile_ape_items_current['data']);
+ 							break;
+ 						}
+ 						if ($this->inline_attachments === true) {
+ 							// great
+ 						} elseif (is_int($this->inline_attachments)) {
+ 							if ($this->inline_attachments < $thisfile_ape_items_current['data_length']) {
+ 								// too big, skip
+ 								$info['warning'][] = 'attachment at '.$thisfile_ape_items_current['offset'].' is too large to process inline ('.number_format($thisfile_ape_items_current['data_length']).' bytes)';
+ 								unset($thisfile_ape_items_current['data']);
+ 								break;
+ 							}
+ 						} elseif (is_string($this->inline_attachments)) {
+ 							$this->inline_attachments = rtrim(str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $this->inline_attachments), DIRECTORY_SEPARATOR);
+ 							if (!is_dir($this->inline_attachments) || !is_writable($this->inline_attachments)) {
+ 								// cannot write, skip
+ 								$info['warning'][] = 'attachment at '.$thisfile_ape_items_current['offset'].' cannot be saved to "'.$this->inline_attachments.'" (not writable)';
+ 								unset($thisfile_ape_items_current['data']);
+ 								break;
+ 							}
+ 						}
+ 						// if we get this far, must be OK
+ 						if (is_string($this->inline_attachments)) {
+ 							$destination_filename = $this->inline_attachments.DIRECTORY_SEPARATOR.md5($info['filenamepath']).'_'.$thisfile_ape_items_current['data_offset'];
+ 							if (!file_exists($destination_filename) || is_writable($destination_filename)) {
+ 								file_put_contents($destination_filename, $thisfile_ape_items_current['data']);
+ 							} else {
+ 								$info['warning'][] = 'attachment at '.$thisfile_ape_items_current['offset'].' cannot be saved to "'.$destination_filename.'" (not writable)';
+ 							}
+ 							$thisfile_ape_items_current['data_filename'] = $destination_filename;
+ 							unset($thisfile_ape_items_current['data']);
+ 						} else {
+ 							if (!isset($info['ape']['comments']['picture'])) {
+ 								$info['ape']['comments']['picture'] = array();
+ 							}
+ 							$info['ape']['comments']['picture'][] = array('data'=>$thisfile_ape_items_current['data'], 'image_mime'=>$thisfile_ape_items_current['image_mime']);
+ 						}
+ 					} while (false);
+ 					break;
+ 
+ 				default:
+ 					if (is_array($thisfile_ape_items_current['data'])) {
+ 						foreach ($thisfile_ape_items_current['data'] as $comment) {
+ 							$thisfile_ape['comments'][strtolower($item_key)][] = $comment;
+ 						}
+ 					}
+ 					break;
+ 			}
+ 
+ 		}
+ 		if (empty($thisfile_replaygain)) {
+ 			unset($info['replay_gain']);
+ 		}
+ 		return true;
+ 	}
+ 
+ 	public function parseAPEheaderFooter($APEheaderFooterData) {
+ 		// http://www.uni-jena.de/~pfk/mpp/sv8/apeheader.html
+ 
+ 		// shortcut
+ 		$headerfooterinfo['raw'] = array();
+ 		$headerfooterinfo_raw = &$headerfooterinfo['raw'];
+ 
+ 		$headerfooterinfo_raw['footer_tag']   =                  substr($APEheaderFooterData,  0, 8);
+ 		if ($headerfooterinfo_raw['footer_tag'] != 'APETAGEX') {
+ 			return false;
+ 		}
+ 		$headerfooterinfo_raw['version']      = getid3_lib::LittleEndian2Int(substr($APEheaderFooterData,  8, 4));
+ 		$headerfooterinfo_raw['tagsize']      = getid3_lib::LittleEndian2Int(substr($APEheaderFooterData, 12, 4));
+ 		$headerfooterinfo_raw['tag_items']    = getid3_lib::LittleEndian2Int(substr($APEheaderFooterData, 16, 4));
+ 		$headerfooterinfo_raw['global_flags'] = getid3_lib::LittleEndian2Int(substr($APEheaderFooterData, 20, 4));
+ 		$headerfooterinfo_raw['reserved']     =                              substr($APEheaderFooterData, 24, 8);
+ 
+ 		$headerfooterinfo['tag_version']         = $headerfooterinfo_raw['version'] / 1000;
+ 		if ($headerfooterinfo['tag_version'] >= 2) {
+ 			$headerfooterinfo['flags'] = $this->parseAPEtagFlags($headerfooterinfo_raw['global_flags']);
+ 		}
+ 		return $headerfooterinfo;
+ 	}
+ 
+ 	public function parseAPEtagFlags($rawflagint) {
+ 		// "Note: APE Tags 1.0 do not use any of the APE Tag flags.
+ 		// All are set to zero on creation and ignored on reading."
+ 		// http://www.uni-jena.de/~pfk/mpp/sv8/apetagflags.html
+ 		$flags['header']            = (bool) ($rawflagint & 0x80000000);
+ 		$flags['footer']            = (bool) ($rawflagint & 0x40000000);
+ 		$flags['this_is_header']    = (bool) ($rawflagint & 0x20000000);
+ 		$flags['item_contents_raw'] =        ($rawflagint & 0x00000006) >> 1;
+ 		$flags['read_only']         = (bool) ($rawflagint & 0x00000001);
+ 
+ 		$flags['item_contents']     = $this->APEcontentTypeFlagLookup($flags['item_contents_raw']);
+ 
+ 		return $flags;
+ 	}
+ 
+ 	public function APEcontentTypeFlagLookup($contenttypeid) {
+ 		static $APEcontentTypeFlagLookup = array(
+ 			0 => 'utf-8',
+ 			1 => 'binary',
+ 			2 => 'external',
+ 			3 => 'reserved'
+ 		);
+ 		return (isset($APEcontentTypeFlagLookup[$contenttypeid]) ? $APEcontentTypeFlagLookup[$contenttypeid] : 'invalid');
+ 	}
+ 
+ 	public function APEtagItemIsUTF8Lookup($itemkey) {
+ 		static $APEtagItemIsUTF8Lookup = array(
+ 			'title',
+ 			'subtitle',
+ 			'artist',
+ 			'album',
+ 			'debut album',
+ 			'publisher',
+ 			'conductor',
+ 			'track',
+ 			'composer',
+ 			'comment',
+ 			'copyright',
+ 			'publicationright',
+ 			'file',
+ 			'year',
+ 			'record date',
+ 			'record location',
+ 			'genre',
+ 			'media',
+ 			'related',
+ 			'isrc',
+ 			'abstract',
+ 			'language',
+ 			'bibliography'
+ 		);
+ 		return in_array(strtolower($itemkey), $APEtagItemIsUTF8Lookup);
+ 	}
+ 
+ }
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ID3/module.tag.id3v1.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ID3/module.tag.id3v1.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/ID3/module.tag.id3v1.php	1969-12-31 18:00:00.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/ID3/module.tag.id3v1.php	2013-03-20 23:55:42.000000000 -0500
***************
*** 0 ****
--- 1,359 ----
+ <?php
+ /////////////////////////////////////////////////////////////////
+ /// getID3() by James Heinrich <info@getid3.org>               //
+ //  available at http://getid3.sourceforge.net                 //
+ //            or http://www.getid3.org                         //
+ /////////////////////////////////////////////////////////////////
+ // See readme.txt for more details                             //
+ /////////////////////////////////////////////////////////////////
+ //                                                             //
+ // module.tag.id3v1.php                                        //
+ // module for analyzing ID3v1 tags                             //
+ // dependencies: NONE                                          //
+ //                                                            ///
+ /////////////////////////////////////////////////////////////////
+ 
+ 
+ class getid3_id3v1 extends getid3_handler
+ {
+ 
+ 	public function Analyze() {
+ 		$info = &$this->getid3->info;
+ 
+ 		if (!getid3_lib::intValueSupported($info['filesize'])) {
+ 			$info['warning'][] = 'Unable to check for ID3v1 because file is larger than '.round(PHP_INT_MAX / 1073741824).'GB';
+ 			return false;
+ 		}
+ 
+ 		fseek($this->getid3->fp, -256, SEEK_END);
+ 		$preid3v1 = fread($this->getid3->fp, 128);
+ 		$id3v1tag = fread($this->getid3->fp, 128);
+ 
+ 		if (substr($id3v1tag, 0, 3) == 'TAG') {
+ 
+ 			$info['avdataend'] = $info['filesize'] - 128;
+ 
+ 			$ParsedID3v1['title']   = $this->cutfield(substr($id3v1tag,   3, 30));
+ 			$ParsedID3v1['artist']  = $this->cutfield(substr($id3v1tag,  33, 30));
+ 			$ParsedID3v1['album']   = $this->cutfield(substr($id3v1tag,  63, 30));
+ 			$ParsedID3v1['year']    = $this->cutfield(substr($id3v1tag,  93,  4));
+ 			$ParsedID3v1['comment'] =                 substr($id3v1tag,  97, 30);  // can't remove nulls yet, track detection depends on them
+ 			$ParsedID3v1['genreid'] =             ord(substr($id3v1tag, 127,  1));
+ 
+ 			// If second-last byte of comment field is null and last byte of comment field is non-null
+ 			// then this is ID3v1.1 and the comment field is 28 bytes long and the 30th byte is the track number
+ 			if (($id3v1tag{125} === "\x00") && ($id3v1tag{126} !== "\x00")) {
+ 				$ParsedID3v1['track']   = ord(substr($ParsedID3v1['comment'], 29,  1));
+ 				$ParsedID3v1['comment'] =     substr($ParsedID3v1['comment'],  0, 28);
+ 			}
+ 			$ParsedID3v1['comment'] = $this->cutfield($ParsedID3v1['comment']);
+ 
+ 			$ParsedID3v1['genre'] = $this->LookupGenreName($ParsedID3v1['genreid']);
+ 			if (!empty($ParsedID3v1['genre'])) {
+ 				unset($ParsedID3v1['genreid']);
+ 			}
+ 			if (isset($ParsedID3v1['genre']) && (empty($ParsedID3v1['genre']) || ($ParsedID3v1['genre'] == 'Unknown'))) {
+ 				unset($ParsedID3v1['genre']);
+ 			}
+ 
+ 			foreach ($ParsedID3v1 as $key => $value) {
+ 				$ParsedID3v1['comments'][$key][0] = $value;
+ 			}
+ 
+ 			// ID3v1 data is supposed to be padded with NULL characters, but some taggers pad with spaces
+ 			$GoodFormatID3v1tag = $this->GenerateID3v1Tag(
+ 											$ParsedID3v1['title'],
+ 											$ParsedID3v1['artist'],
+ 											$ParsedID3v1['album'],
+ 											$ParsedID3v1['year'],
+ 											(isset($ParsedID3v1['genre']) ? $this->LookupGenreID($ParsedID3v1['genre']) : false),
+ 											$ParsedID3v1['comment'],
+ 											(!empty($ParsedID3v1['track']) ? $ParsedID3v1['track'] : ''));
+ 			$ParsedID3v1['padding_valid'] = true;
+ 			if ($id3v1tag !== $GoodFormatID3v1tag) {
+ 				$ParsedID3v1['padding_valid'] = false;
+ 				$info['warning'][] = 'Some ID3v1 fields do not use NULL characters for padding';
+ 			}
+ 
+ 			$ParsedID3v1['tag_offset_end']   = $info['filesize'];
+ 			$ParsedID3v1['tag_offset_start'] = $ParsedID3v1['tag_offset_end'] - 128;
+ 
+ 			$info['id3v1'] = $ParsedID3v1;
+ 		}
+ 
+ 		if (substr($preid3v1, 0, 3) == 'TAG') {
+ 			// The way iTunes handles tags is, well, brain-damaged.
+ 			// It completely ignores v1 if ID3v2 is present.
+ 			// This goes as far as adding a new v1 tag *even if there already is one*
+ 
+ 			// A suspected double-ID3v1 tag has been detected, but it could be that
+ 			// the "TAG" identifier is a legitimate part of an APE or Lyrics3 tag
+ 			if (substr($preid3v1, 96, 8) == 'APETAGEX') {
+ 				// an APE tag footer was found before the last ID3v1, assume false "TAG" synch
+ 			} elseif (substr($preid3v1, 119, 6) == 'LYRICS') {
+ 				// a Lyrics3 tag footer was found before the last ID3v1, assume false "TAG" synch
+ 			} else {
+ 				// APE and Lyrics3 footers not found - assume double ID3v1
+ 				$info['warning'][] = 'Duplicate ID3v1 tag detected - this has been known to happen with iTunes';
+ 				$info['avdataend'] -= 128;
+ 			}
+ 		}
+ 
+ 		return true;
+ 	}
+ 
+ 	public static function cutfield($str) {
+ 		return trim(substr($str, 0, strcspn($str, "\x00")));
+ 	}
+ 
+ 	public static function ArrayOfGenres($allowSCMPXextended=false) {
+ 		static $GenreLookup = array(
+ 			0    => 'Blues',
+ 			1    => 'Classic Rock',
+ 			2    => 'Country',
+ 			3    => 'Dance',
+ 			4    => 'Disco',
+ 			5    => 'Funk',
+ 			6    => 'Grunge',
+ 			7    => 'Hip-Hop',
+ 			8    => 'Jazz',
+ 			9    => 'Metal',
+ 			10   => 'New Age',
+ 			11   => 'Oldies',
+ 			12   => 'Other',
+ 			13   => 'Pop',
+ 			14   => 'R&B',
+ 			15   => 'Rap',
+ 			16   => 'Reggae',
+ 			17   => 'Rock',
+ 			18   => 'Techno',
+ 			19   => 'Industrial',
+ 			20   => 'Alternative',
+ 			21   => 'Ska',
+ 			22   => 'Death Metal',
+ 			23   => 'Pranks',
+ 			24   => 'Soundtrack',
+ 			25   => 'Euro-Techno',
+ 			26   => 'Ambient',
+ 			27   => 'Trip-Hop',
+ 			28   => 'Vocal',
+ 			29   => 'Jazz+Funk',
+ 			30   => 'Fusion',
+ 			31   => 'Trance',
+ 			32   => 'Classical',
+ 			33   => 'Instrumental',
+ 			34   => 'Acid',
+ 			35   => 'House',
+ 			36   => 'Game',
+ 			37   => 'Sound Clip',
+ 			38   => 'Gospel',
+ 			39   => 'Noise',
+ 			40   => 'Alt. Rock',
+ 			41   => 'Bass',
+ 			42   => 'Soul',
+ 			43   => 'Punk',
+ 			44   => 'Space',
+ 			45   => 'Meditative',
+ 			46   => 'Instrumental Pop',
+ 			47   => 'Instrumental Rock',
+ 			48   => 'Ethnic',
+ 			49   => 'Gothic',
+ 			50   => 'Darkwave',
+ 			51   => 'Techno-Industrial',
+ 			52   => 'Electronic',
+ 			53   => 'Pop-Folk',
+ 			54   => 'Eurodance',
+ 			55   => 'Dream',
+ 			56   => 'Southern Rock',
+ 			57   => 'Comedy',
+ 			58   => 'Cult',
+ 			59   => 'Gangsta Rap',
+ 			60   => 'Top 40',
+ 			61   => 'Christian Rap',
+ 			62   => 'Pop/Funk',
+ 			63   => 'Jungle',
+ 			64   => 'Native American',
+ 			65   => 'Cabaret',
+ 			66   => 'New Wave',
+ 			67   => 'Psychedelic',
+ 			68   => 'Rave',
+ 			69   => 'Showtunes',
+ 			70   => 'Trailer',
+ 			71   => 'Lo-Fi',
+ 			72   => 'Tribal',
+ 			73   => 'Acid Punk',
+ 			74   => 'Acid Jazz',
+ 			75   => 'Polka',
+ 			76   => 'Retro',
+ 			77   => 'Musical',
+ 			78   => 'Rock & Roll',
+ 			79   => 'Hard Rock',
+ 			80   => 'Folk',
+ 			81   => 'Folk/Rock',
+ 			82   => 'National Folk',
+ 			83   => 'Swing',
+ 			84   => 'Fast-Fusion',
+ 			85   => 'Bebob',
+ 			86   => 'Latin',
+ 			87   => 'Revival',
+ 			88   => 'Celtic',
+ 			89   => 'Bluegrass',
+ 			90   => 'Avantgarde',
+ 			91   => 'Gothic Rock',
+ 			92   => 'Progressive Rock',
+ 			93   => 'Psychedelic Rock',
+ 			94   => 'Symphonic Rock',
+ 			95   => 'Slow Rock',
+ 			96   => 'Big Band',
+ 			97   => 'Chorus',
+ 			98   => 'Easy Listening',
+ 			99   => 'Acoustic',
+ 			100  => 'Humour',
+ 			101  => 'Speech',
+ 			102  => 'Chanson',
+ 			103  => 'Opera',
+ 			104  => 'Chamber Music',
+ 			105  => 'Sonata',
+ 			106  => 'Symphony',
+ 			107  => 'Booty Bass',
+ 			108  => 'Primus',
+ 			109  => 'Porn Groove',
+ 			110  => 'Satire',
+ 			111  => 'Slow Jam',
+ 			112  => 'Club',
+ 			113  => 'Tango',
+ 			114  => 'Samba',
+ 			115  => 'Folklore',
+ 			116  => 'Ballad',
+ 			117  => 'Power Ballad',
+ 			118  => 'Rhythmic Soul',
+ 			119  => 'Freestyle',
+ 			120  => 'Duet',
+ 			121  => 'Punk Rock',
+ 			122  => 'Drum Solo',
+ 			123  => 'A Cappella',
+ 			124  => 'Euro-House',
+ 			125  => 'Dance Hall',
+ 			126  => 'Goa',
+ 			127  => 'Drum & Bass',
+ 			128  => 'Club-House',
+ 			129  => 'Hardcore',
+ 			130  => 'Terror',
+ 			131  => 'Indie',
+ 			132  => 'BritPop',
+ 			133  => 'Negerpunk',
+ 			134  => 'Polsk Punk',
+ 			135  => 'Beat',
+ 			136  => 'Christian Gangsta Rap',
+ 			137  => 'Heavy Metal',
+ 			138  => 'Black Metal',
+ 			139  => 'Crossover',
+ 			140  => 'Contemporary Christian',
+ 			141  => 'Christian Rock',
+ 			142  => 'Merengue',
+ 			143  => 'Salsa',
+ 			144  => 'Thrash Metal',
+ 			145  => 'Anime',
+ 			146  => 'JPop',
+ 			147  => 'Synthpop',
+ 
+ 			255  => 'Unknown',
+ 
+ 			'CR' => 'Cover',
+ 			'RX' => 'Remix'
+ 		);
+ 
+ 		static $GenreLookupSCMPX = array();
+ 		if ($allowSCMPXextended && empty($GenreLookupSCMPX)) {
+ 			$GenreLookupSCMPX = $GenreLookup;
+ 			// http://www.geocities.co.jp/SiliconValley-Oakland/3664/alittle.html#GenreExtended
+ 			// Extended ID3v1 genres invented by SCMPX
+ 			// Note that 255 "Japanese Anime" conflicts with standard "Unknown"
+ 			$GenreLookupSCMPX[240] = 'Sacred';
+ 			$GenreLookupSCMPX[241] = 'Northern Europe';
+ 			$GenreLookupSCMPX[242] = 'Irish & Scottish';
+ 			$GenreLookupSCMPX[243] = 'Scotland';
+ 			$GenreLookupSCMPX[244] = 'Ethnic Europe';
+ 			$GenreLookupSCMPX[245] = 'Enka';
+ 			$GenreLookupSCMPX[246] = 'Children\'s Song';
+ 			$GenreLookupSCMPX[247] = 'Japanese Sky';
+ 			$GenreLookupSCMPX[248] = 'Japanese Heavy Rock';
+ 			$GenreLookupSCMPX[249] = 'Japanese Doom Rock';
+ 			$GenreLookupSCMPX[250] = 'Japanese J-POP';
+ 			$GenreLookupSCMPX[251] = 'Japanese Seiyu';
+ 			$GenreLookupSCMPX[252] = 'Japanese Ambient Techno';
+ 			$GenreLookupSCMPX[253] = 'Japanese Moemoe';
+ 			$GenreLookupSCMPX[254] = 'Japanese Tokusatsu';
+ 			//$GenreLookupSCMPX[255] = 'Japanese Anime';
+ 		}
+ 
+ 		return ($allowSCMPXextended ? $GenreLookupSCMPX : $GenreLookup);
+ 	}
+ 
+ 	public static function LookupGenreName($genreid, $allowSCMPXextended=true) {
+ 		switch ($genreid) {
+ 			case 'RX':
+ 			case 'CR':
+ 				break;
+ 			default:
+ 				if (!is_numeric($genreid)) {
+ 					return false;
+ 				}
+ 				$genreid = intval($genreid); // to handle 3 or '3' or '03'
+ 				break;
+ 		}
+ 		$GenreLookup = self::ArrayOfGenres($allowSCMPXextended);
+ 		return (isset($GenreLookup[$genreid]) ? $GenreLookup[$genreid] : false);
+ 	}
+ 
+ 	public static function LookupGenreID($genre, $allowSCMPXextended=false) {
+ 		$GenreLookup = self::ArrayOfGenres($allowSCMPXextended);
+ 		$LowerCaseNoSpaceSearchTerm = strtolower(str_replace(' ', '', $genre));
+ 		foreach ($GenreLookup as $key => $value) {
+ 			if (strtolower(str_replace(' ', '', $value)) == $LowerCaseNoSpaceSearchTerm) {
+ 				return $key;
+ 			}
+ 		}
+ 		return false;
+ 	}
+ 
+ 	public static function StandardiseID3v1GenreName($OriginalGenre) {
+ 		if (($GenreID = self::LookupGenreID($OriginalGenre)) !== false) {
+ 			return self::LookupGenreName($GenreID);
+ 		}
+ 		return $OriginalGenre;
+ 	}
+ 
+ 	public static function GenerateID3v1Tag($title, $artist, $album, $year, $genreid, $comment, $track='') {
+ 		$ID3v1Tag  = 'TAG';
+ 		$ID3v1Tag .= str_pad(trim(substr($title,  0, 30)), 30, "\x00", STR_PAD_RIGHT);
+ 		$ID3v1Tag .= str_pad(trim(substr($artist, 0, 30)), 30, "\x00", STR_PAD_RIGHT);
+ 		$ID3v1Tag .= str_pad(trim(substr($album,  0, 30)), 30, "\x00", STR_PAD_RIGHT);
+ 		$ID3v1Tag .= str_pad(trim(substr($year,   0,  4)),  4, "\x00", STR_PAD_LEFT);
+ 		if (!empty($track) && ($track > 0) && ($track <= 255)) {
+ 			$ID3v1Tag .= str_pad(trim(substr($comment, 0, 28)), 28, "\x00", STR_PAD_RIGHT);
+ 			$ID3v1Tag .= "\x00";
+ 			if (gettype($track) == 'string') {
+ 				$track = (int) $track;
+ 			}
+ 			$ID3v1Tag .= chr($track);
+ 		} else {
+ 			$ID3v1Tag .= str_pad(trim(substr($comment, 0, 30)), 30, "\x00", STR_PAD_RIGHT);
+ 		}
+ 		if (($genreid < 0) || ($genreid > 147)) {
+ 			$genreid = 255; // 'unknown' genre
+ 		}
+ 		switch (gettype($genreid)) {
+ 			case 'string':
+ 			case 'integer':
+ 				$ID3v1Tag .= chr(intval($genreid));
+ 				break;
+ 			default:
+ 				$ID3v1Tag .= chr(255); // 'unknown' genre
+ 				break;
+ 		}
+ 
+ 		return $ID3v1Tag;
+ 	}
+ 
+ }
